﻿local Cartographer = Cartographer
local revision = tonumber(("$Revision: 26973 $"):sub(12, -3))
if revision > Cartographer.revision then
	Cartographer.version = "r" .. revision
	Cartographer.revision = revision
	Cartographer.date = ("$Date: 2007-02-02 11:01:12 -0500 (Fri, 02 Feb 2007) $"):sub(8, 17)
end

local L = AceLibrary("AceLocale-2.2"):new("Cartographer-Waypoints")
local Tourist = AceLibrary("Tourist-2.0")

L:RegisterTranslations("enUS", function() return {
	["Waypoints"] = true,
	["Module which shows an arrow to direct you to a specified note or location."] = true,
	["Hint: /waypoint is available to create waypoints with the command line."] = true,

	["Waypoint cleared."] = true,
	["Waypoint set: %s %.1f,%.1f"] = true,
	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title] OR here (sets a waypoint arrow at your current location)"] = true,
	["Console-waypoint-commands"] = {"/way", "/waypoint" },
	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = true,
	["Clear waypoint"] = true,
	["here"] = true,
	["Waypoint Marker"] = true,
	["No target found."] = true,
	["Warning: ambiguous zone %s specified, selected %s as possible match."] = true,
	["(%s)"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Waypoints"] = "위치 포인트",
	["Module which shows an arrow to direct you to a specified note or location."] = "당신이 작성한 노트나 위치를 화살표로 안내하는 모듈입니다.",
	["Hint: /waypoint is available to create waypoints with the command line."] = "힌트: 명령어로 위치 포인트를 새로 만들기 위해 /waypoint를 이용할 수 있습니다.",

	["Waypoint cleared."] = "위치 포인트가 삭제되었습니다.",
	["Waypoint set: %s %.1f,%.1f"] = "위치 설정: %s %.1f,%.1f",
--	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title]"] = true,
--	["Console-waypoint-commands"] = {"/way", "/waypoint" },
--	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
--	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = true,
	["Clear waypoint"] = "위치 포인트 삭제",
	["here"] = "이곳으로",
	["Waypoint Marker"] = "위치 포인트 기록",
	["No target found."] = "대상을 찾을수 없습니다.",
	["Warning: ambiguous zone %s specified, selected %s as possible match."] = "경고: 정확하지 않은 지역 %s|1을;를; 찾았습니다. 가능하면 %s|1을;를; 선택하세요.",
	["(%s)"] = "(%s)",
} end)

L:RegisterTranslations("deDE", function() return {
	["Waypoints"] = "Wegpunkte",
	["Module which shows an arrow to direct you to a specified note or location."] = "Modul das einen Pfeil anzeigt um dich zu einer ausgewählten Notiz oder Position zu führen.",
	["Hint: /waypoint is available to create waypoints with the command line."] = "Hinweis: /waypoint ist vorhanden um einen Wegpunkt zu erstellen per Kommando Zeilen Befehl.",

	["Waypoint cleared."] = "Wegpunkt gelöscht",
	["Waypoint set: %s %.1f,%.1f"] = "Wegpunkt gesetzt: %s %.1f,%.1f",
	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title] OR here (sets a waypoint arrow at your current location)"] = "Benutzung: /waypoint <such text> ODER <0-100>,<0-100> [titel] ODER hier (erstellt einen Wegpunkt Pfeil auf deiner gegenwärtigen Position)",
	["Console-waypoint-commands"] = {"/way", "/waypoint" },
	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = "(%d+.?%d*)[, ](%d+.?%d*) ?(.*)",
	["Clear waypoint"] = "Entferne Wegpunkt",
	["Warning: ambiguous zone %s specified, selected %s as possible match."] = "Warnung: Keine eindeutige zone %s spezifiziert, wähle %s als mögliches Ziel.",
	["(%s)"] = "(%s)",
} end)

L:RegisterTranslations("frFR", function() return {
	["Waypoints"] = "Points d'arrivée",
	["Module which shows an arrow to direct you to a specified note or location."] = "Module affichant une flèche vous conduisant vers une note ou un endroit spécifié.",
	["Hint: /waypoint is available to create waypoints with the command line."] = "Astuce : la commande /waypoint est disponible pour créer des points d'arrivée par ligne de commande.",

	["Waypoint cleared."] = "Point d'arrivée effacé.",
	["Waypoint set: %s %.1f,%.1f"] = "Point d'arrivée établi : %s %.1f,%.1f",
	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title] OR here (sets a waypoint arrow at your current location)"] = "Utilisation : /waypoint <texte recherché> OU <0-100>,<0-100> [titre] OU ici (établi le point d'arrivée à votre position actuelle)",
	["Console-waypoint-commands"] = {"/way", "/waypoint" },
	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = "(%d+.?%d*)[, ](%d+.?%d*) ?(.*)",
	["Clear waypoint"] = "Effacer le point d'arrivée",
	["here"] = "ici",
	["Waypoint Marker"] = "Waypoint Marker",
	["No target found."] = "Aucune cible trouvée.",
	["Warning: ambiguous zone %s specified, selected %s as possible match."] = "Attention: zone ambiguë %s spécifié, %s choisi comme correspondance possible.",
	["(%s)"] = "(%s)",
} end)

L:RegisterTranslations("esES", function() return {
	["Waypoints"] = "Puntos de ruta",
	["Module which shows an arrow to direct you to a specified note or location."] = "M\195\179dulo que muestra una flecha indicando un lugar o nota especificada",
	["Hint: /waypoint is available to create waypoints with the command line."] = "Consejo: /waypoint est\195\161 disponible para crear puntos de ruta con la l\195\173nea de comandos",

	["Waypoint cleared."] = "Punto de ruta eliminado",
	["Waypoint set: %s %.1f,%.1f"] = "Punto de ruta establecido: %s %.1f,%.1f",
	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title] OR here (sets a waypoint arrow at your current location)"] = "Uso: /waypoint <texto a buscar> OR <0-100>,<0-100> [t\195\173tulo] OR here (coloca una flecha de punto de ruta en tu posici\195\179n actual)",
	["Console-waypoint-commands"] = {"/way", "/waypoint" },
	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
	["Clear waypoint"] = "Eliminar punto de ruta",
	["Warning: ambiguous zone %s specified, selected %s as possible match."] = "Aviso: zona %s especificada ambigua, elegida %s como posible coincidencia.",
	["(%s)"] = "(%s)",
} end)

L:RegisterTranslations("zhTW", function() return {
--	["Waypoints"] = true,
--	["Module which shows an arrow to direct you to a specified note or location."] = true,
--	["Hint: /waypoint is available to create waypoints with the command line."] = true,
--
--	["Waypoint cleared."] = true,
--	["Waypoint set: %s %.1f,%.1f"] = true,
--	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title]"] = true,
--	["Console-waypoint-commands"] = {"/way", "/waypoint" },
--	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
--	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = true,
--	["Clear waypoint"] = true,
--	["Warning: ambiguous zone %s specified, selected %s as possible match."] = true,
	["(%s)"] = "(%s)",
} end)

Cartographer_Waypoints = Cartographer:NewModule("Waypoints", "AceHook-2.1", "AceEvent-2.0", "AceComm-2.0", "AceConsole-2.0")
local Cartographer_Waypoints = Cartographer_Waypoints
local self = Cartographer_Waypoints

local Dewdrop = AceLibrary("Dewdrop-2.0")
local Tablet = AceLibrary("Tablet-2.0")
local Tourist = AceLibrary("Tourist-2.0")
local Crayon = AceLibrary("Crayon-2.0")
local BZ = AceLibrary("Babble-Zone-2.2")

local _G = getfenv(0)
local metric = GetLocale() ~= "enUS"

local yardString = GetLocale() == "enUS" and "%.0f yd" or "%.0f m"

local math_floor = math.floor

local playerModel

local function round(num, digits)
	-- banker's rounding
	local mantissa = 10^digits
	local norm = num*mantissa
	norm = norm + 0.5
	local norm_f = math_floor(norm)
	if norm == norm_f and (norm_f % 2) ~= 0 then
		return (norm_f-1)/mantissa
	end
	return norm_f/mantissa
end

local function getID(x, y)
	return round(x*10000, 0) + round(y*10000, 0)*10001
end
Cartographer_Waypoints.getID = getID

local function getXY(id)
	return (id % 10001)/10000, math_floor(id / 10001)/10000
end
Cartographer_Waypoints.getXY = getXY

local function getrawpoi(zone, id, creator)
	if creator then
		local v = Cartographer_Notes.externalDBs[creator]
		if v and rawget(v, zone) and rawget(v[zone], id) then
			return v[zone][id], creator
		end
		return
	end
	for k,v in pairs(Cartographer_Notes.externalDBs) do
		if rawget(v, zone) and rawget(v[zone], id) then
			return v[zone][id], k
		end
	end
	if rawget(Cartographer_Notes.db.account.pois, zone) then
		local t = rawget(Cartographer_Notes.db.account.pois[zone], id)
		if t then
			return t, nil
		end
	end
end


local function parseArrivalOptions(text,origQuery)
	if not text or string.len(text) < 1 then
		return
	end
	
	-- delete on arrival with a-delete
	local delete = text and string.find(text,"delete") and "delete" or nil
	
	-- hide on arrival with a-hide
	local hide = text and string.find(text,"hide") and "hide" or nil
	
	return text, delete, hide
end

local path
function Cartographer_Waypoints:OnInitialize()
	path = debugstack(1, 1, 0)
	if path:find("grapher\\") then
		path = "Interface\\AddOns\\Cartographer\\Cartographer_Waypoints\\Artwork\\"
	elseif path:find("grapher_Waypoints\\") then
		path = "Interface\\AddOns\\Cartographer_Waypoints\\Artwork\\"
	else
		error("Cannot determine path of artwork")
	end
	self.db = Cartographer:AcquireDBNamespace("Waypoints")
	
	Cartographer:RegisterDefaults("Waypoints", "profile", {
		showYardsAway = true,
		waypointX = 0,
		waypointY = 0,
	})

	-- waypoints are temporary notes and are not saved in a database
	Cartographer_Waypoints.waypoints = {}

	Cartographer_Notes:RegisterNotesDatabase("Waypoints", Cartographer_Waypoints.waypoints, self)

	self.name = L["Waypoints"]
	self.title = L["Waypoints"]
	Cartographer.options.args.Waypoints = {
		name = L["Waypoints"],
		desc = L["Module which shows an arrow to direct you to a specified note or location."], 
		type = 'group',
		args = {
			toggle = {
				name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
				desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
				type = "toggle",
				order = -1,
				get = function() return Cartographer:IsModuleActive(self) end,
				set = function() Cartographer:ToggleModuleActive(self) end
			},
		},
		handler = self,
	}
end

function Cartographer_Waypoints:OnEnable()
	self:RegisterChatCommand({"/noway"},function()
		self:Print(L["Waypoint cleared."])
		self:SetNoteAsWaypoint()
	end)
	
	local DEFAULT_MIN_DIST = 30
	
	local function waypointCommand(text,temp)
		if not text or string.len(text) < 1 then
			self:Print(L["Usage: /waypoint <search text> OR <0-100>,<0-100> [title] OR here (sets a waypoint arrow at your current location)"])
			return
		end
		local x,y,t = string.match(text,L["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"])
        
		local function optionFunc(opt,text)
			if not text then return end
			
			local i,j,out = nil
			-- set new icon with i-
			i,j,out = string.find(text, opt..'%-(%b"")')
			if not i then
				i,j,out = string.find(text, opt.."%-(%b'')")
			end
			if not i then
				i,j,out = string.find(text, opt.."%-([^%s]+)")
			end

			if out and string.find(out,"^['\"]") then
				out = string.sub(out,2,-2)
			end
			
			if i then
				local h,t = strtrim(string.sub(text,1,i-1)),string.sub(text,j+1)
				if h:len() < 1 then
					t = strtrim(t)
				end
				text = h..t
			end
			
			if string.len(text) < 1 then text = nil end
			
			return out,text
		end

		local pzone = Cartographer:GetCurrentLocalizedZoneName()
		
		if x then
			x,y,text = tonumber(x)/100,tonumber(y)/100,t
		
			local arrive, icon, azone
			arrive, text = optionFunc('a',text)
			if temp then
				arrive = arrive and arrive..";delete" or "delete"
			end
			icon, text = optionFunc('i',text)
			azone, text = optionFunc('z',text)
			arrive = parseArrivalOptions(arrive,text)

			local szone, notexact = azone and Cartographer_Notes:FindZone(azone)

			if notexact then
				self:Print(L["Warning: ambiguous zone %s specified, selected %s as possible match."],azone,szone)
			end
			
			local zone = pzone
			self:Print(string.format(L["Waypoint set: %s %.1f,%.1f"],szone or zone,x * 100,y * 100))
			Cartographer_Notes:SetNote(szone or zone, x, y,icon or "Cross",
				temp and "Waypoints" or UnitName("player"), 'title', text or L["Waypoint Marker"])
			self:SetNoteAsWaypoint(szone or zone,x,y,arrive,text)

			return
		else
			local arrive, minDist, azone, icon

			arrive, text = optionFunc('a',text)
			minDist, text = optionFunc('d',text)
			icon, text = optionFunc('i',text)
			azone, text = optionFunc('z',text)
			arrive = parseArrivalOptions(arrive,text)
			text = string.lower(text)
			
			minDist = minDist and tonumber(minDist) or DEFAULT_MIN_DIST
			local _zone,_x,_y,_print
			local here = L["here"]
			if string.find(text,here) == 1 then
				text = strtrim(text:sub(here:len()+1))
				_x,_y,_zone = Cartographer:GetCurrentPlayerPosition()
				_print = text and text:len() > 0 and text or L["Waypoint Marker"]
				
				Cartographer_Notes:SetNote(_zone, _x, _y,icon or "Cross",
					temp and "Waypoints" or UnitName("player"), 'title', _print)
				
				if temp then
					arrive = arrive and arrive..";delete" or "delete"
				end
			else
				_zone,_x,_y,_print = Cartographer_Notes:FindNote(text,azone,nil,nil,minDist)
				
				if temp then
					arrive = arrive and arrive..";hide" or "hide"
				end
			end
			
			if _zone == nil then
				self:Print(L["No target found."])
				self:SetNoteAsWaypoint()
				return
			end

			local oldz,oldx,oldy = self:GetWaypoint()
			if _print then
				if _zone ~= oldz or _x ~= oldx or _y ~= oldy then
					self:Print(string.format(L["Waypoint set: %s %.1f,%.1f"],_print,_x * 100,_y * 100),_zone ~= pzone and string.format(L["(%s)"],_zone))
					self:SetNoteAsWaypoint(_zone,_x,_y,arrive,_print)
				end
			else
				if oldz then
					self:Print(L["Waypoint cleared."]);
					self:SetNoteAsWaypoint()
				end
			end
		end
	end
	
	self:RegisterChatCommand(L["Console-temp-waypoint-commands"],function(text)
		waypointCommand(text,true)
	end)

	self:RegisterChatCommand(L["Console-waypoint-commands"],function(text)
		waypointCommand(text)
	end)

	if not playerModel then
		local t = { Minimap:GetChildren() }
		for i = #t, 1, -1 do
			local v = t[i]
			if v:GetObjectType() == "Model" and not v:GetName() then
				playerModel = v
				break
			end
		end
	end
end

local continentWpZone, continentWpId, worldWpZone, worldWpId
local waypointZone, waypointX, waypointY

function Cartographer_Waypoints:ZONE_CHANGED_NEW_AREA()
	self:ScheduleRepeatingEvent("CartographerWaypoints-UpdateWaypoint", self.UpdateWaypoint, 0.05, self)
end

function Cartographer_Waypoints:GetWaypoint()
	return waypointZone, waypointX, waypointY
end

function Cartographer_Waypoints:IsNoteWaypoint(zone, x, y)
	local id
	AceLibrary.argCheck(self, zone, 2, "string", "nil")
	if zone then
		if not BZ:HasTranslation(zone) then
			if BZ:HasReverseTranslation(zone) then
				zone = BZ:GetReverseTranslation(zone)
			else
				error(("Trying to set a waypoint with an unknown zone: %q"):format(zone), 2)
			end
		end
		if not y then
			id = x
			AceLibrary.argCheck(self, x, 3, "number")
			x, y = getXY(id)
		else
			AceLibrary.argCheck(self, x, 3, "number")
			AceLibrary.argCheck(self, y, 4, "number")
			if x < 0 or x > 1 then
				error(("Argument #3 to `SetNoteAsWaypoint' is expected to be [0, 1], got %s"):format(x), 2)
			end
			if y < 0 or y > 1 then
				error(("Argument #4 to `SetNoteAsWaypoint' is expected to be [0, 1], got %s"):format(y), 2)
			end
			id = getID(x, y)
		end
	else
		return not waypointZone
	end
	
	if not waypointZone then
		return false
	end
	
	local wid = getID(waypointX, waypointY)
	return waypointZone == zone and id == wid
end


local waypointArrivalOption
local function waypointArrivalAction(cleared)
	text,delete, hide, rep, repArg, nxt, nextArg = parseArrivalOptions(waypointArrivalOption)
	waypointArrivalOption = nil
	
	if delete then
		Cartographer_Notes:DeleteNote(waypointZone,waypointX,waypointY)
	elseif hide then
		Cartographer_Waypoints:SetNoteAsWaypoint()
	end
	
	-- TODO if cleared set do not set any new waypoints
end

local Kalimdor, Eastern_Kingdoms, Outland = GetMapContinents()
if not Outland then
	Outland = BZ["Outland"]
end

local waypointFrame
local waypointLocalZone
function Cartographer_Waypoints:SetNoteAsWaypoint(zone, x, y, arrivalOptions, title)
	AceLibrary.argCheck(self, zone, 2, "string", "nil")
	
	if continentWpZone then
		if Cartographer_Notes:GetNote(continentWpZone,getXY(continentWpId)) then
			Cartographer_Notes:DeleteNote(continentWpZone,continentWpId)
		end
		
		continentWpZone,continentWpId = nil
	end

	if worldWpZone then
		if Cartographer_Notes:GetNote(worldWpZone,getXY(worldWpId)) then
			Cartographer_Notes:DeleteNote(worldWpZone,worldWpId)
		end
		
		worldWpZone,worldWpId = nil
	end

	if zone then
		AceLibrary.argCheck(self, arrivalOptions, 5, "string", "nil")
		
		waypointArrivalOption = arrivalOptions or ""
		
		if not BZ:HasTranslation(zone) then
			if BZ:HasReverseTranslation(zone) then
				zone = BZ:GetReverseTranslation(zone)
			else
				error(("Trying to set a waypoint with an unknown zone: %q"):format(zone), 2)
			end
		end
		local id
		if type(y) == "string" or type(y) == "nil" then
			id = x
			title = y or ""
			AceLibrary.argCheck(self, x, 3, "number")
			x, y = getXY(id)
		else
			AceLibrary.argCheck(self, x, 3, "number")
			AceLibrary.argCheck(self, y, 4, "number")
			if x < 0 or x > 1 then
				error(("Argument #3 to `SetNoteAsWaypoint' is expected to be [0, 1], got %s"):format(x), 2)
			end
			if y < 0 or y > 1 then
				error(("Argument #4 to `SetNoteAsWaypoint' is expected to be [0, 1], got %s"):format(y), 2)
			end
			id = getID(x, y)
		end

		local continent = Tourist:GetContinent(zone)
		if continent then
			local _,_,_, icon, db, data = Cartographer_Notes:GetNote(zone,x,y)
			local cX, cY = Tourist:TransposeZoneCoordinate(x,y,zone,continent)
			
            if cX then
                Cartographer_Notes:SetNote(continent,cX,cY,icon or "Cross","Waypoints",type(data) == "string" and data or data and data.title or L["Waypoint Marker"])
                
                continentWpZone = continent
                continentWpId = getID(cX,cY)
                
                if continent ~= Outland then
                    local azeroth = BZ["Azeroth"]
                    local wX, wY = Tourist:TransposeZoneCoordinate(x,y,zone,azeroth)
                    
                    Cartographer_Notes:SetNote(azeroth,wX,wY,icon or "Cross","Waypoints",type(data) == "string" and data or data and data.title or L["Waypoint Marker"])
                    
                    worldWpZone = azeroth
                    worldWpId = getID(wX,wY)
                end
            end
		end

		local data, db = getrawpoi(zone, id)
		if not data and title ~= L["Waypoint Marker"] then
			return
		end
		waypointZone, waypointX, waypointY, waypointTitle = zone, x, y, title
		waypointLocalZone = BZ[zone]
		
		self:ScheduleRepeatingEvent("CartographerWaypoints-UpdateWaypoint", self.UpdateWaypoint, 0.05, self)
	
		if not waypointFrame then
			waypointFrame = CreateFrame("Frame", "Cartographer_Waypoint", UIParent)
			waypointFrame:SetWidth(56)
			waypointFrame:SetHeight(64)
			waypointFrame:Show()
			local tex = waypointFrame:CreateTexture(nil, "OVERLAY")
			waypointFrame.tex = tex
			tex:SetWidth(56)
			tex:SetHeight(42)
			tex:SetTexture(path .. "Arrow")
			waypointFrame.up = false
			tex:SetPoint("TOP")
			local dist = waypointFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
			waypointFrame.dist = dist
			dist:SetPoint("BOTTOM")
			local title = waypointFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
			waypointFrame.title = title
			title:SetPoint("TOP", waypointFrame, "BOTTOM")
			local zone = waypointFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
			waypointFrame.zone = zone
			zone:SetPoint("TOP", title, "BOTTOM")
			waypointFrame:EnableMouse(true)
			waypointFrame:SetMovable(true)
			waypointFrame:RegisterForDrag("LeftButton")
			waypointFrame:SetScript("OnDragStart", function(this)
				this:StartMoving()
			end)
			waypointFrame:SetScript("OnDragStop", function(this)
				this:StopMovingOrSizing()
				local x,y = this:GetCenter()
				x = x - GetScreenWidth() / 2
				y = y - GetScreenHeight() / 2
				self.db.profile.waypointX = x
				self.db.profile.waypointY = y
				this:ClearAllPoints()
				this:SetPoint("CENTER", UIParent, "CENTER", x, y)
			end)
			waypointFrame:SetClampedToScreen(true)
			waypointFrame:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.waypointX, self.db.profile.waypointY)
			Dewdrop:Register(waypointFrame,
				'children', function()
					Dewdrop:AddLine(
						'text', L["Clear waypoint"],
						'arg1', self,
						'func', "SetNoteAsWaypoint",
						'closeWhenClicked', true
					)
					Dewdrop:AddLine()
					Dewdrop:AddLine(
						'text', CLOSE,
						'closeWhenClicked', true
					)
				end
			)
		end
		waypointFrame:Show()
	else
		self:CancelScheduledEvent("CartographerWaypoints-UpdateWaypoint")
		if waypointFrame then
			waypointFrame:Hide()
		end
		if waypointZone and Cartographer_Notes:GetNote(waypointZone,waypointX,waypointY) then
			waypointArrivalAction(true)
		end
		waypointZone, waypointLocalZone, waypointX, waypointY, waypointArrivalOption = nil
	end
end

local _54_div_math_pi = 54/math.pi
local math_rad_90 = math.rad(90)
local math_atan2 = math.atan2
local math_floor = math.floor
local count = 53
function Cartographer_Waypoints:UpdateWaypoint()
	local realZoneText = GetRealZoneText()
	if not (waypointZone and waypointLocalZone and realZoneText) then
		self:CancelScheduledEvent("CartographerWaypoints-UpdateWaypoint")
        waypointFrame:Hide()
		return
	end
	
	local px, py = Cartographer:GetCurrentPlayerPosition()
	if not px then
		return
	end
	
	local x, y = Tourist:TransposeZoneCoordinate(waypointX, waypointY, waypointLocalZone, realZoneText)
	if not x then
		self:CancelScheduledEvent("CartographerWaypoints-UpdateWaypoint")
        waypointFrame:Hide()
		return
	end
	local dist = Cartographer:GetDistanceToPoint(waypointX, waypointY, waypointLocalZone)
	if not dist and waypointTitle ~= L["Waypoint Marker"] then
		Cartographer_Waypoints:SetNoteAsWaypoint(nil)
		return
	end
	if dist <= 5 then
		if waypointArrivalOption and waypointTitle ~= L["Waypoint Marker"] then
			local arrivalOpt = waypointArrivalOption
			waypointArrivalAction()
			Cartographer_Waypoints:TriggerEvent("CartographerWaypoints_WaypointHit",waypointZone,waypointX,waypointY,arrivalOpt)
		end
	end
	if dist <=10 then
		if not waypointFrame.up then
			waypointFrame.tex:SetTexture(path .. "Arrow-UP")
			waypointFrame.tex:SetWidth(53)
			waypointFrame.tex:SetHeight(70)
			waypointFrame.up = true
		end
	else
		if waypointFrame.up then
			waypointFrame.tex:SetTexture(path .. "Arrow")
			waypointFrame.tex:SetWidth(56)
			waypointFrame.tex:SetHeight(42)
			waypointFrame.up = false
		end
	end
	
	if not waypointFrame.up then
		local diffX, diffY = x - px, y - py
		local rad = -math_atan2(diffY*2/3, diffX)
		local direction = playerModel:GetFacing() + math_rad_90
		local val = ((rad - direction)*_54_div_math_pi + 108) % 108
		local col, row = math_floor(val % 9), math_floor(val / 9)
		waypointFrame.tex:SetTexCoord(col*56/512, (col+1)*56/512, row*42/512, (row+1)*42/512)
	else
		count = count + 1
		if count == 54 then
			count = 0
		end
		local col, row = math_floor(count % 9), math_floor(count / 9)
		waypointFrame.tex:SetTexCoord(col*53/512, (col+1)*53/512, row*70/512, (row+1)*70/512)
	end
	waypointFrame.tex:SetVertexColor(Crayon:GetThresholdColorTrivial(dist, 1000, 300, 100, 30, 0))
	
	waypointFrame.dist:SetText(yardString:format(dist))
	waypointFrame.title:SetText(waypointTitle)
	waypointFrame.zone:SetText(waypointLocalZone == realZoneText and "" or waypointLocalZone)
end

function Cartographer_Waypoints:OnProfileEnable()
	self:RefreshMap()
	if waypointFrame then
		waypointFrame:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.x, self.db.profile.y)
	end
end

function Cartographer_Waypoints:IsNoteHidden(zone, id, data, inMinimap)
	-- TODO if creator is player show it
	-- otherwise check prefs to show/hide notes from players of different guild ranks
	-- can't hide notice waypoints from officers
end

function Cartographer_Waypoints:IsMiniNoteHidden(zone,id,data)
end